#!/usr/bin/env bash
# THIS FILE IS PART OF THE CYLC WORKFLOW ENGINE.
# Copyright (C) NIWA & British Crown (Met Office) & Contributors.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------
# Validate and run the task events workflow.
. "$(dirname "$0")/test_header"
#-------------------------------------------------------------------------------
set_test_number 3
#-------------------------------------------------------------------------------
install_workflow "${TEST_NAME_BASE}" "${TEST_NAME_BASE}"
create_test_global_config '
[platforms]
    [[test platform]]
        hosts = NOHOST.NODOMAIN
'
#-------------------------------------------------------------------------------
run_ok "${TEST_NAME_BASE}-validate" cylc validate \
    --set=WORKFLOW_LOG_DIR=\""${WORKFLOW_RUN_DIR}/log/workflow"\" \
    "${WORKFLOW_NAME}"
workflow_run_ok "${TEST_NAME_BASE}-run" \
    cylc play --reference-test --debug --no-detach \
    --set=WORKFLOW_LOG_DIR=\""${WORKFLOW_RUN_DIR}/log/workflow"\" \
    "${WORKFLOW_NAME}"
sort -u 'events.log' >'expected.events.log'
sed 's/ (after .*)$//' "${WORKFLOW_RUN_DIR}/log/workflow/events.log" | sort -u \
    >'actual.events.log'
cmp_ok 'actual.events.log' 'expected.events.log'
#-------------------------------------------------------------------------------
purge
exit
